## 2.9.2 - 2024-10-07
Minor addition to the last update: Fixed an issue that could prevent the "Post Content" dynamic tag from rendering if the WP_Query was rebuilt inside the post template block.

## 2.9.1 - 2024-10-04
Fixed high prio issue preventing the single post content from being rendered when using the "Post Content" dynamic tag.

## 2.9.0 - 2024-10-01
**Features**

* Render accordion content as structured JSON-LD data

**Improvements**

* Adjust dashboard changelog for newer format
* A11Y: remove unnecessary title attribute on Submit Button block
* Dynamic image: make sizeSlug dynamic
* Popup admin script error handling
* Interactions with hidden fields are not saved anymore
* Wrap greyd popover in list element when it is child of core/navigation
* Render shortcodes in dynamic tags from posttype custom fields
* Posttypes meta field placeholder now control text
* Improved rendering of submenues in navigation

**Bugfixes**

* Fixed the rendering of custom meta-fields media-links for posttype 'product'
* Fixed autosearch when rest-search response is a string
* Fixed fatal error on post import when 'parent' is a WP_Term object
* Fixed rendering of icon if trigger is used on core button block
* Hide anything in :before on hidden-trigger-link
* Fixed dynamic support in greyd/popover-button block
* Fixed getDisplayVal function in Greyd.Forms Public JS
* Fixed loading spinner position in live search
* Fixed groups ignoring max-width
* Stretch img tag if SVG is used (editor only)
* Fixed advanced filter reversed order
* Fixed rendering of global dynamic tags
* Fixed alignment of greyd/button block in editor
* Changed unique id of popover block to avoid duplicates
* Fixed potential endless loop caused by updating block attributes from within the child and parent at the same time
* Dynamic Template Embeds were not displayed in frontend when original embed block is empty

## 2.8.0 - 2024-09-03
**Features**

* The HTML structure of the post slider block can now be customized
* New button options to align the icon separately to the content
* New button option to keep a button optional even with an icon set (eg. when used in dynamic templates)
* Added theme support for the new section stylings in groups and columns

**Improvements**

* Reworked translations accross all plugins
* Group backgrounds can now be made dynamic
* Video backgrounds can now be made dynamic
* Videos can now be dynamically be replaced using post data (such as meta options)
* Improved a contrast ratio inside the license banner
* Improved the handling of polylang translations with post import and global content
* Hierarchy inside taxonomy terms is not being lost after post import, even when the post does not have a parent term relationship
* Selected terms inside query loop advanced filter are not being lost on post import
* Form entry export can be accessed using a separate capability, allowig for further customization
* New notification directky inside the editor, when a wp-template is not using a main-element
* Accessibility improvements for: range-slider, form after message, dynamic form tags, conditional container
* The link picker now supports aria-labels

**Bugfixes**

* Fixed various issues in the greyd list inside the editor after the latest apiVersion update
* Fixed an issue that lead to animations being gone inside the editor after a reload
* Fixed an issue that lead to trigger being gone inside the editor after a reload
* Fixed a Javascript error inside popups
* Fixed an issue not displaying gradients when a preset color was removed in the global styles
* Image block aspect ratio was incorrectly labelled '3:4' twice
* Accordion icons were not display correctly in the editor
* Fixed accordion horizontal overflow
* Border in accordions was affecting parent and child element at the same time
* Fixed an error with registration linsks from within form mails
* Fixed downgrade links inside license admin page
* Fixed an issue with different ImagePanel options when they have the same name
* Fixed a Javascript error on ImagePanel Select inside popup
* Fixed margins inside radio buttons on classic sites
* Fixed a potential fatal error after the latest when using a WPBakery setup
* Fixed a compatibility issue calling the the_content filter incorrectly when using the dynamic tag 'content'
* Dynamic images in media and text block where not compatible with the latest WordPress update

## 2.7.2 - 2024-08-13
**Bugfixes**

* Fixed form script enqueue in classic_suite and autoptimize setups
* Fixed greyd.data for advanced filter
* Fixed a javascript error in editor
* Fixed perPage/items sync in nested query loops
* Enabled advancedFilter for core Post-Template
* Fixed issues exporting forms that link to pages by ID

## 2.7.1 - 2024-08-02
**Bugfixes**

* Fixed an issue that lead to classes and IDs not being saved in the content box markup
* Fixed an issue where a post slider was not filtered live, when the search bar was wrapped in multiple blocks

## 2.7.0 - 2024-08-01
**Features**

* New Query & Search Features:
* Added a date picker and several filter buttons blocks
* New post slider features
* Improved support for core query loop and search features
* Live search now works with every query loop independently from the search template

**Improvements**

* Adjustments for compatibility with WordPress 6.6
* Hide empty accordion items
* Breaking Change: The default query loop is no longer rendered as a slider with pagination. This affects only the completely empty default state, which was previously incorrect.

**Bugfixes**

* Fixed a permissions issue with the Greyd installer
* Added missing blocks-query.css
* Fixed too small iframe in template editing mode
* Fixed a problem with background CSS classes in content boxes
* Fixed an issue with popups with several triggers
* Fixed a padding issue in navigation sub menus
* Fixed some issues that could occur when switching to a child theme
* Fixed an issue with Dynamic Tags

## 2.6.0 - 2024-07-10
**Improvements**

* Theme JSON 3.0: Utilize new Features
* Conditional Content: Time-Based Live Conditions

**Bugfixes**

* fixed some problems with wordings
* Single Post Content is not rendered as expected with ARMember Plugin
* fixed some issues with the theme assets import/export
* fixed an issue with the Dynamic Tag "number of posts"
* fixed an compatibility issue with Gutenberg 18.3
* fixed a javascript issue when a wp-template was included inside a dynamic template

## 2.5.1 - 2024-06-21
* Adhoc fix for block validation error inside columns

## 2.5.0 - 2024-06-21
**Improvements**

* Greyd blocks now support spacing preset sizes
* added gap settings for buttons
* added buttons focus outline
* added uppercase & letter spacing as global styling option for greyd buttons
* moved popover block to navigation menus (beta)
* moved popup block rendering to php

**Bugfixes**

* fixed an issue where meta fields disappeared in forms
* fixed multiple issues with the hub import
* fixed an issue with alignments in frontend and backend in greyd blocks
* fixed an issue with the pinned box
* fixed an issue with max and min attributes in forms
* fixed an issue with the edit template button
* fixed an issue with the cover block and dynamic variables
* fixed an issue with the fluid option settings
* fixed an issue with the bulk export of templates and template parts
* fixed an issue with the alignment of list icons
* fixed an issue with the converter
* fixed an issue with lottie animations
* fixed a critical error in single page templates
* fixed an issue with missing break points

## 2.4.2 - 2024-06-10
* Patch for creating bootstrap-styled responsive columns

## 2.4.0 - 22.05.2024
* Re-added index.php to the Greyd Theme to prevent error when using child themes.

## 2.4.0 - 22.05.2024
**Improvements**

* Release of the new Greyd Theme in the official repo
* Make Google and custom fonts deprecation notice always visible in Greyd Global Styles
* Anchor active navigation do now support all types of anchor links

**Bugfixes**

* Added 'classic' flag to all template library system templates
* Fixed an issue not closing all popups using the ESC key
* Fixed an issue where the second header does not open the selected offmenu
* Fixed an issue displayinmg form tooltips outside of the screen
* Removed z-index overwrite for floating boxes.
* Fixed an issue where custom fonts did not display dotted query paginations

## 2.3.0 - 08.05.2024
**Bugfixes**

* Resolved a fatal error in the Site Editor caused by the Headless feature.
* Fixed SSL error occurring during Post Export.
* Corrected post type filter on the global content page.
* Addressed unrecognized conflicts during Global Content Import.
* Implemented filtering of selected query live filter terms.
* Fixed incorrect display of Theme Status.
* Set the slider max-width for new layout controls to 1200.
* Corrected the incorrect display of checkbox styles as radio-buttons or switch inputs.
* Removed a misleading error message within form interfaces.
* Added the plugin filter to filter_post_id function in Greyd.Forms.
* Removed background-isolation & z-index causing z-stacking errors after
* Removed orphaned search result styling leading to errors
* Fixed Reference Error in Search & Replace Feature to Post_Export feature.
* Fixed an issue with gradient presets after migrating the theme converter to the plugin.
* Fixed isolation for backgrounds in classic versions.
* Fixed errors in post export regex patterns if anchor attribute is set (usually as the first attribute).
* Fixed some issues in the Automator and Synced_Posttype classes used for the Headless Posttype features.
* Fixed caching issues on global content list pages with remote connection contents.
* Fixed rendering of forms when the filtered post-id does not exist anymore (e.g., in polylang after manual import).
* Only send verification mail during redo-option action when the user is not verified.
* Fixed an error during Hub-Import when Global Content is not verified.
* Fixed an issue where Safari-based browsers could not calculate the height of images correctly.
* Fixed an issue calculating the default height of post slider pages.

**Improvements**

* Updated Readme Files.
* Added the ability to manually repair global styles.
* Improved UI of Greyd-tabs components inside the block editor.
* Added architecture documentation to Global Content Readme.
* Adjusted spacing scaling controls for new layoutControl components.
* Added license filtering for better security & auto-validation through constant support.
* Added the possibility to customize the animation speed via the global var 'greydSliderSpeed'.
* Removed orphaned greyd_tp_management references.
* Improved error handling in Greyd.Forms Hubspot API.


## 2.2.0 - 12.04.2024
**Bugfixes**

* fixed a bug where authors could not edit dynamic templates in post content
* fixed a problem with conditional fields 
* fixed a problem with multistep forms
* fixed multiple compatibility issues with woocommerce
* fixed a compatibility issue with gutenberg where the navigation block was causing a block error when clicking on the typography panel
* fixed an issue with the site connector
* fixed a compatibility issue with polylang
* fixed an issue with revisions and dynamic tags
* fixed an issue where the query loop crashed in page templates
* fixed a block error with the query loop when selecting a single post 
* fixed an issue with wrong alignment of greyd buttons in the frontend
* fixed an issue with videos in frontend when lazyload was no activated
* fixed multiple issues with small differences between frontend and editor
* fixed an issue with custom selects not wrapping correctly
* fixed a block error with greyd buttons

**Improvements**

* added an extra incompatibility notice for old classic fullsite templates
